import { WebApiConfig, ApiError } from "./trycatch-web-api.models";
import { Router } from "@angular/router";
import { HttpClient } from "@angular/common/http";
import { Observable } from "rxjs";
import { LocalStorageService } from "@trycatch/local-storage";
export declare class WebApiService {
    private http;
    private localStorage;
    private router;
    private config;
    private progressEvent;
    progressEvent$: Observable<number>;
    private errorSubject;
    webApiError: Observable<ApiError>;
    constructor(http: HttpClient, localStorage: LocalStorageService, router: Router, config: WebApiConfig);
    get<T>(api: string, useBaseUrl?: boolean, extraHeaders?: {
        [key: string]: any;
    }): Observable<T>;
    private postUrlEncoded;
    post<T>(api: any, body: any, useBaseUrl?: boolean, responseType?: string, contentType?: string): Observable<T>;
    private transformPayloadToFormUrlEncoded;
    update<T>(api: any, item: any, useBaseUrl?: boolean): Observable<T>;
    delete<T>(api: any, item: any, useBaseUrl?: boolean): Observable<T>;
    private fullUrl;
    errorHandler(apiError: ApiError): Observable<never>;
}
